<template>
  <form
    class="fr-container--fluid"
    @submit.prevent="onSaveHelpRequest"
  >
    <div class="fr-grid-row fr-grid-row--gutters form-grid">
      <AtomInput
        class="fr-col-12 fr-col-lg-6"
        name="opening_date"
        label="Date d'ouverture du dossier"
        type="date"
        :value="helpRequest ? helpRequest.opening_date : TODAY"
        required
      />

      <AtomInput
        v-if="isMinistryAgent"
        name="numero_pegase"
        label="Numéro Pégase"
        :value="helpRequest ? helpRequest.numero_pegase : ''"
      />

      <AtomSelect
        v-if="isMinistryAgent"
        name="ministre"
        label="Ministre"
        :options="withEmptyValue(MINISTRE_OPTIONS)"
      />

      <AtomSearchableSelect
        class="fr-col-12 fr-col-lg-6"
        label="Objet de la demande"
        name="follow_up_type"
        :options="followUpTypeOptions"
        :value="helpRequest ? helpRequest.follow_up_type : ''"
        required
        hint
      >
        <template #hint>
          <span class="fr-icon-information-line fr-fi--sm">
            <NuxtLink
              v-if="canEditOrganisation"
              :to="Routes.OrganisationEdit"
              target="_self"
            >
              Personnaliser les objets des demandes de ma structure.
            </NuxtLink>
            <template v-else>
              Les responsables de votre structure peuvent personnaliser ces
              objets des demandes.
            </template>
          </span>
        </template>
      </AtomSearchableSelect>

      <AtomSearchableSelect
        label="Organisme prescripteur"
        name="organisme_prescripteur"
        :options="organismesPrescripteursOptions"
        :value="
          helpRequest && helpRequest.organisme_prescripteur
            ? String(helpRequest.organisme_prescripteur)
            : ''
        "
        :can-create-new-option="canCreateOrganisme"
      />

      <AtomSelect
        v-model="status"
        name="status"
        label="Statut"
        :options="HELP_REQUEST_STATUS_OPTIONS"
        :disabled-options="pastStatuses"
      />

      <AtomCheckbox
        name="full_file"
        label="Dossier complet"
        :model-value="helpRequest && helpRequest.full_file"
      />

      <AtomSelect
        v-model="financialSupport"
        class="fr-col-12 fr-col-lg-6"
        :class="{ 'fr-col-offset-lg-6--right': !isFinancialSupport }"
        label="S'agit-il d'une aide financière ?"
        name="financial_support"
        :options="withEmptyValue(FINANCIAL_SUPPORT_OPTIONS)"
        required
        :disabled="!!helpRequest"
      />

      <AtomSelect
        v-if="isFinancialSupport"
        name="reason"
        label="Motif"
        :options="withEmptyValue(HELP_REQUEST_REASON_OPTIONS)"
        :model-value="helpRequest ? helpRequest.reason : ''"
        :disabled="isEditingAndIsLocked"
      />

      <AtomSelect
        v-model="externalOrganisation"
        class="fr-col-12 fr-col-lg-6"
        :class="{
          'fr-col-offset-lg-6--right': !isExternalSupport
        }"
        label="L'instruction de la demande est réalisée..."
        name="external_organisation"
        :options="withEmptyValue(EXTERNAL_ORGANISATION_OPTIONS)"
        required
        :disabled="!!helpRequest"
      />

      <AtomSearchableSelect
        v-if="isExternalSupport"
        label="Organisme instructeur"
        name="organisme_instructeur"
        :options="organismesInstructeursOptions"
        :value="
          helpRequest && helpRequest.organisme_instructeur
            ? String(helpRequest.organisme_instructeur)
            : ''
        "
        :readonly="isEditingAndIsLocked"
        :can-create-new-option="canCreateOrganisme"
      />

      <template v-if="externalOrganisation && financialSupport">
        <AtomCurrencyInput
          v-if="isFinancialSupport"
          name="asked_amount"
          label="Montant demandé"
          :value="helpRequest ? helpRequest.asked_amount : ''"
          :readonly="isEditingAndIsLocked"
        />

        <template v-if="afterInvestigationOngoing">
          <AtomInput
            v-if="isExternalSupport"
            name="dispatch_date"
            label="Date d'envoi du dossier"
            type="date"
            :value="helpRequest ? helpRequest.dispatch_date : ''"
            :readonly="isEditingAndIsLocked"
          />

          <AtomInput
            v-if="!isExternalSupport"
            name="examination_date"
            label="Date de passage en commission"
            type="date"
            :value="helpRequest ? helpRequest.examination_date : ''"
            :readonly="isEditingAndIsLocked"
          />
        </template>

        <AtomInput
          v-if="isAnswered"
          name="decision_date"
          label="Date de la décision"
          type="date"
          :value="helpRequest ? helpRequest.decision_date : ''"
        />

        <template v-if="status === ACCEPTED_STATUS_VALUE">
          <template v-if="isFinancialSupport">
            <AtomCurrencyInput
              name="allocated_amount"
              label="Montant attribué"
              :value="helpRequest ? helpRequest.allocated_amount : ''"
            />

            <template v-if="!isExternalSupport">
              <AtomSelect
                name="payment_method"
                label="Mode de paiement"
                :options="withEmptyValue(PAYMENT_METHOD_OPTIONS)"
                :model-value="helpRequest ? helpRequest.payment_method : ''"
              />

              <AtomInput
                name="payment_date"
                label="Date du paiement"
                type="date"
                :value="helpRequest ? helpRequest.payment_date : ''"
              />
            </template>
          </template>

          <AtomInput
            name="handling_date"
            label="Date de fin de prise en charge"
            type="date"
            :value="helpRequest ? helpRequest.handling_date : ''"
          />
        </template>

        <AtomInput
          v-if="status === REFUSED_STATUS_VALUE"
          name="refusal_reason"
          label="Motif du refus"
          :value="helpRequest ? helpRequest.refusal_reason : ''"
        />
      </template>

      <AtomInput
        name="due_date"
        label="Date d'échéance"
        type="date"
        :value="helpRequest ? helpRequest.due_date : ''"
        :readonly="isDropped"
      />

      <AtomTextarea
        class="fr-col-12 large-textarea"
        name="synthesis"
        label="Compte rendu"
        :value="helpRequest ? helpRequest.synthesis : ''"
      />

      <AtomTextarea
        v-if="isOwnedByCurrentUser"
        class="fr-col-12 fr-mb-6v"
        name="private_synthesis"
        label="Compte rendu privé"
        label-icon="fr-icon-lock-line"
        hint
        :value="
          helpRequest ? helpRequest.private_synthesis[0].private_synthesis : ''
        "
      >
        <template #hint>
          Le compte rendu privé est uniquement visible et modifiable par l'agent
          qui crée l'instruction de demande d'aide.<br />{{
            SENSITIVE_DATA_HINT
          }}
        </template>
      </AtomTextarea>
    </div>

    <BeneficiaryDocumentsSelect
      class="fr-mb-4w"
      :beneficiary-id="beneficiaryId"
      name="documents"
      label="Documents"
      :value="initialDocumentIds"
    />

    <ul
      class="fr-btns-group fr-btns-group--inline fr-btns-group--lg fr-btns-group--right"
    >
      <li>
        <button
          class="fr-btn submit-btn"
          type="submit"
          :submitting="isSubmitting"
          :disabled="isSubmitting"
        >
          Enregistrer
        </button>
      </li>
    </ul>
  </form>
</template>

<script setup>
  import {
    newOptionToLabel,
    parseKindOfBoolean,
    prepareM2MRelation,
    toOptions,
    withEmptyValue
  } from '~/utils'
  import { NEW_OPTION_PREFIX, SENSITIVE_DATA_HINT } from '~/utils/constants'
  import {
    ACCEPTED_STATUS_VALUE,
    CLOSED_BY_BENEFICIARY_STATUS_VALUE,
    DISMISSED_STATUS_VALUE,
    REFUSED_STATUS_VALUE,
    WAITING_ADDITIONAL_INFORMATION_STATUS_VALUE,
    HELP_REQUEST_STATUS_OPTIONS,
    FINANCIAL_SUPPORT_OPTIONS,
    HELP_REQUEST_REASON_OPTIONS,
    EXTERNAL_ORGANISATION_OPTIONS,
    PAYMENT_METHOD_OPTIONS,
    pastStatusesFromStatus
  } from '~/utils/constants/help-requests'
  import { useAuthStore } from '~/store/auth'
  import { MINISTRE_OPTIONS } from '~~/utils/constants/ministry'
  import { usePermissionsStore } from '~/store/permissions'
  import { Routes } from '~/utils/routing/routes'

  const { $dayjs } = useNuxtApp()
  const isMinistryAgent = useMinistryAgent()
  const authStore = useAuthStore()
  const permissionsStore = usePermissionsStore()

  const TODAY = $dayjs().format('YYYY-MM-DD')

  const props = defineProps({
    isSubmitting: { type: Boolean, required: true },
    followUpTypes: { type: Array, required: true },
    helpRequest: { type: Object, default: null },
    beneficiaryId: { type: String, required: true },
    organismesPrescripteurs: { type: Array, required: true },
    organismesInstructeurs: { type: Array, required: true }
  })

  const emit = defineEmits(['saveHelpRequest'])

  const status = ref(
    props.helpRequest?.status || WAITING_ADDITIONAL_INFORMATION_STATUS_VALUE
  )
  const financialSupport = ref('')
  const externalOrganisation = ref('')

  const followUpTypeOptions = computed(() =>
    toOptions(props.followUpTypes, 'id', 'name')
  )

  const isFinancialSupport = computed(() =>
    parseKindOfBoolean(financialSupport.value)
  )

  const isExternalSupport = computed(() =>
    parseKindOfBoolean(externalOrganisation.value)
  )

  const afterInvestigationOngoing = computed(
    () => status.value !== WAITING_ADDITIONAL_INFORMATION_STATUS_VALUE
  )

  const isAnswered = computed(
    () =>
      status.value === ACCEPTED_STATUS_VALUE ||
      status.value === REFUSED_STATUS_VALUE
  )

  const isDropped = computed(
    () =>
      status.value === CLOSED_BY_BENEFICIARY_STATUS_VALUE ||
      status.value === DISMISSED_STATUS_VALUE
  )

  const isEditingAndIsLocked = computed(
    () => props.helpRequest && (isAnswered.value || isDropped.value)
  )

  const pastStatuses = computed(() => {
    if (!props.helpRequest) return []
    return pastStatusesFromStatus(props.helpRequest.status)
  })

  const isOwnedByCurrentUser = computed(() =>
    permissionsStore.ownsItem(props.helpRequest)
  )

  const canEditOrganisation = computed(
    () => permissionsStore.canEditOrganisation
  )

  const initialDocumentIds = computed(
    () => props.helpRequest?.documents.map(d => d.directus_file) || []
  )

  const organismesPrescripteursOptions = computed(() => {
    const organismesPrescripteursWithStringId =
      props.organismesPrescripteurs.map(op => ({ ...op, id: String(op.id) }))
    return toOptions(organismesPrescripteursWithStringId, 'id', 'name')
  })

  const canCreateOrganisme = computed(() => permissionsStore.canCreateOrganisme)

  const organismesInstructeursOptions = computed(() => {
    const organismesInstructeursWithStringId = props.organismesInstructeurs.map(
      op => ({ ...op, id: String(op.id) })
    )
    return toOptions(organismesInstructeursWithStringId, 'id', 'name')
  })

  onMounted(() => {
    if (props.helpRequest) {
      financialSupport.value = props.helpRequest.financial_support
        ? 'true'
        : 'false'
      externalOrganisation.value = props.helpRequest.external_organisation
        ? 'true'
        : 'false'
    }
  })

  function onSaveHelpRequest({ target }) {
    const helpRequest = prepareHelpRequest(target)
    emit('saveHelpRequest', helpRequest)
  }

  function prepareHelpRequest(form) {
    const helpRequest = Object.fromEntries(new FormData(form))

    helpRequest.financial_support = parseKindOfBoolean(
      helpRequest.financial_support
    )
    helpRequest.external_organisation = parseKindOfBoolean(
      helpRequest.external_organisation
    )

    if (isOwnedByCurrentUser.value) {
      helpRequest.private_synthesis = [
        { private_synthesis: helpRequest.private_synthesis }
      ]

      if (props.helpRequest?.private_synthesis.length) {
        helpRequest.private_synthesis[0].id =
          props.helpRequest.private_synthesis[0].id
      }
    }

    helpRequest.beneficiary = { id: props.beneficiaryId }

    // Set empty documents field to null
    if (!helpRequest.documents) helpRequest.documents = null

    helpRequest.documents = prepareM2MRelation(
      props.helpRequest?.documents,
      helpRequest.documents?.split(',') || [],
      'directus_file'
    )

    if (helpRequest.organisme_prescripteur?.startsWith(NEW_OPTION_PREFIX)) {
      helpRequest.organisme_prescripteur = {
        name: newOptionToLabel(helpRequest.organisme_prescripteur),
        organisation: authStore.userOrganisationId
      }
    }

    if (helpRequest.organisme_instructeur?.startsWith(NEW_OPTION_PREFIX)) {
      helpRequest.organisme_instructeur = {
        name: newOptionToLabel(helpRequest.organisme_instructeur),
        organisation: authStore.userOrganisationId
      }
    }

    return helpRequest
  }
</script>
